#include "libpropeller/sd/sd.h"
#include <stdio.h>


/*
SD with Tests.side

SD Minimal modified so that it tests for drive and file before performing
any read/write operations.  
  
http://learn.parallax.com/propeller-c-simple-devices/sd-card-data
 */
int DO = 22, CLK = 23, DI = 24, CS = 25; // SD card pins on Activity Board


int main(void) // main function
{
    /*
    // simpletools version
    int erc = sd_mount(DO, CLK, DI, CS); // Mount SD card

    if (!erc) // Error code = 0, good, continue
    {
        FILE* fp = fopen("test.txt", "w"); // Open a file for writing

        if (fp) // Nonzero file pointer?  
        { // Good, continue
            fwrite("Test message, hello!\n", 1, 21, fp); // Add contents to the file
        } else // Zero file pinter?
        { // Bad, error message.
            printf("File did not open.\n");
        }
        fclose(fp); // Close the file

        fp = fopen("test.txt", "r"); // Reopen file for reading.

        char s[80]; // Buffer for characters.

        if (fp) // Nonzero file pinter?  
        { // Good, continue.
            printf("First 21 chars in test.txt:\n"); // Display heading
            fread(s, 1, 21, fp); // Read 21 characters
            printf("%s", s); // Display them
            printf("\n"); // With a newline at the end.
        } else // Zero file pointer?
        { // Bad, print error.
            printf("File did not open.\n");
            printf("\n");
        }
        fclose(fp); // Close the file.
    } else // Mount error code not zero?
    { // Bad, display code
        printf("Error opening card.");
        printf("error code = %d\n", erc);
    }
     */
    
    
    // libpropeller version
    SD sd;
    sd.Mount(DO,CLK,DI,CS);
    
    if (sd.HasError() == false)
    {
        sd.Open("test.txt", 'w');

        if (sd.HasError() == false)
        { // Good, continue
            sd.Put("Test message, hello!\n"); // Add contents to the file
        } else // Zero file pinter?
        { // Bad, error message.
            printf("File did not open.\n");
        }
        sd.Close(); // Close the file

        sd.Open("test.txt", 'r'); // Reopen file for reading.

        char s[80]; // Buffer for characters.

        if (sd.HasError() == false)
        { // Good, continue.
            printf("First 21 chars in test.txt:\n"); // Display heading
            sd.Get(s, 21); // Read 21 characters
            printf("%s", s); // Display them
            printf("\n"); // With a newline at the end.
        } else // Zero file pointer?
        { // Bad, print error.
            printf("File did not open.\n");
            printf("\n");
        }
        sd.Close(); // Close the file.
    } else // Mount error code not zero?
    { // Bad, display code
        printf("Error opening card.");
        printf("error code = %d\n", sd.GetError());
    }
    

    return 0;
}